#include "drow.h"
#include <algorithm>
#include <math.h>

drow::drow(RNG &rng, const position_list &available_positions):
        character{rng, race::rdrow} {
        pos = available_positions[rng.rand_under(available_positions.size())];
        gold = 0;
        hostile = true;
}

result drow::attack(const direction dir, character_list &chlist) {
        position tmp{pos + MOVE[dir]};

        for (auto &ch : chlist)
                if (tmp == ch.get_position()) {
                        return ch.get_hit(race, ATK, base_hit_rate);
                }

        return result::fine;
}

result drow::get_hit(const enum race &race, const int atk,
                      const float hitrate) {
        if (rng.rand_num() <= hitrate * (float)RAND_MAX) 
                HP = std::max(HP - calc_dmg(atk, DEF), 0);

        if (HP == 0)
                return result::died;

        return result::hit;
}
