#ifndef __GAME_H__
#define __GAME_H__
#include <memory>
#include <vector>
#include "constants.h"
#include "display.h"
#include "input.h"
#include "rng.h"
#include "characters.h"
#include "map.h"
#include "log.h"

class game final {
private:
        feature features;
        input   &in;
        display &out;
        logger  &log;
        RNG     &rng;
        std::unique_ptr<character> player;
public:
        game(const feature enabled_features,
             input   &new_in,
             display &new_out,
             logger  &new_log,
             RNG     &new_rng);
        game_status run();
private:
        int getcmd() const;
};

#endif
