#include "goblin.h"
#include <algorithm>
#include <math.h>

goblin::goblin(RNG &rng, const position_list &available_positions):
        character{rng, race::rshade} {
        pos = available_positions[rng.rand_under(available_positions.size())];
        gold = 0;
        hostile = true;
}

result goblin::attack(const direction dir, character_list &chlist) {
        position tmp{pos + MOVE[dir]};

        for (auto &ch : chlist)
                if (tmp == ch.get_position()) {
                        auto res = ch.get_hit(race, ATK, base_hit_rate);

                        if (res == result::died) {
                                gold += GAIN_GOLD;
                        }

                        return res;
                }

        return result::fine;
}

result goblin::get_hit(const enum race &race, const int atk,
                       const float hitrate) {
        if (rng.rand_num() <= hitrate * (float)RAND_MAX)
                HP = std::max(HP - calc_dmg(atk, DEF), 0);

        if (HP == 0)
                return result::died;

        return result::hit;
}
