/*
 * CS 246 Final Project
 * File: map.h
 * Purpose: handles map functionality
 */

#ifndef __POSITION_H__
#define __POSITION_H__
#include <vector>

typedef struct position {
        int x;
        int y;

        position();
        position(int nx, int ny);

        position operator+(const position &other) const;
        position &operator=(const position &other);
        position &operator+=(const position &other);
        bool operator==(const position &other) const;
        bool operator!=(const position &other) const;
        bool operator<(const position &other) const;
} position;

std::size_t find(const std::vector<position> &sorted_list,
                 const position &target);

#endif
